<?php
DEFINE(DATABASE , 'preservation');
DEFINE(HOST     , 'localhost');
DEFINE(USER     , 'root');
DEFINE(PASSWORD , '');

class DB {
   /* -------------------------------------------------------------------------- 
   		Connect/Disconnect/Create Database!   
   ----------------------------------------------------------------------------- */     
   
   # ---------------------------------------------------------------------------   
   # DATABASE TABLE REFERENCES
   # ---------------------------------------------------------------------------

   # dynamic structure with data, media etc.
   var $tbl_collections        = 'collections';   
   var $tbl_media              = 'media';
   var $tbl_hyper_media        = 'hyper_media';
   var $tbl_media_entries      = 'media_entries';
   var $tbl_data               = 'data';
   var $tbl_status             = 'status';
   
   # static structure
   var $tbl_releases           = 'releases';
   var $tbl_release_genre      = 'release_genre';
   var $tbl_data_genre         = 'data_genre';
   var $tbl_publishers         = 'publishers';
   var $tbl_publisher_types    = 'publisher_types';   
   var $tbl_release_publishers = 'release_publishers';
   var $tbl_data_release       = 'data_release';
   var $tbl_data_publishers    = 'data_publishers';
   var $tbl_previews           = 'previews';
   var $tbl_preview_types      = 'preview_types';
   var $tbl_release_types      = 'release_types';
   var $tbl_operative_systems  = 'operative_systems';
   # ---------------------------------------------------------------------------
   
   function DB() 
   {
       $this->link = mysql_connect(HOST, USER, PASSWORD);
       if (!$this->link)  {die('DB error #1: ' . mysql_error());}            
       $db_selected = mysql_select_db(DATABASE);

       # Automatical setup database if system is not up...
       # maybe it should be checked if the database does exist or not prior to action...
       if (!$db_selected)
       {
        $this->create_db_structure();
        $db_selected = mysql_select_db(DATABASE);
        if (!$db_selected){die('DB error #2: ' . mysql_error());}
       }
   }
   
   
   function close() 
   {
       mysql_close($this->link);
   }
    
   function create_db_structure(){
    $this->query("CREATE DATABASE " .DATABASE. " DEFAULT CHARACTER SET latin1 COLLATE latin1_swedish_ci;");
    $this->query("USE " . DATABASE );    
    $this->query("CREATE TABLE IF NOT EXISTS `collections` ( `id` int(11) NOT NULL AUTO_INCREMENT, `name` varchar(255) NOT NULL, `created` datetime NOT NULL, PRIMARY KEY (`id`)) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;");
    $this->query("CREATE TABLE IF NOT EXISTS `data` (`id` int(11) NOT NULL AUTO_INCREMENT, `md5` varchar(32) NOT NULL, `sysline` varchar(128) NOT NULL, `bytes` int(11) NOT NULL, `error_bytes` varchar(255) NOT NULL, `error_bits` varchar(4) NOT NULL DEFAULT '0', `status_id` int(11) NOT NULL DEFAULT '1', `operative_system_id` int(11) NOT NULL, `comment` varchar(128) NOT NULL, `block_1` varchar(255) NOT NULL, `data` varchar(10) NOT NULL, PRIMARY KEY (`md5`), UNIQUE KEY `id` (`id`), KEY `status_id` (`status_id`), KEY `operative_system_id` (`operative_system_id`), KEY `block_1` (`block_1`), KEY `sysline` (`sysline`)) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;");  
    $this->query("CREATE TABLE IF NOT EXISTS `data_publishers` (`data_md5` varchar(32) NOT NULL, `publisher_id` int(11) NOT NULL, `release_type_id` int(11) NOT NULL, KEY `publisher_id` (`publisher_id`), KEY `release_type_id` (`release_type_id`), KEY `data_md5` (`data_md5`)) ENGINE=MyISAM DEFAULT CHARSET=latin1;");     
    $this->query("CREATE TABLE IF NOT EXISTS `data_release` (`data_md5` varchar(32) NOT NULL,`release_id` int(11) NOT NULL, UNIQUE KEY `data_md5` (`data_md5`), KEY `release_id` (`release_id`)) ENGINE=MyISAM DEFAULT CHARSET=latin1;");   
    $this->query("CREATE TABLE IF NOT EXISTS `hyper_media` ( `id` int(11) NOT NULL AUTO_INCREMENT, `collection_id` int(11) NOT NULL, `media_md5` varchar(32) NOT NULL, `source` varchar(255) NOT NULL, `physical_label` varchar(255) NOT NULL, `physical_cover` varchar(255) NOT NULL, PRIMARY KEY (`id`), KEY `collection_id` (`collection_id`), KEY `media_md5` (`media_md5`)) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;");  
    $this->query("CREATE TABLE IF NOT EXISTS `media` (`md5` varchar(32) NOT NULL, `label` varchar(26) NOT NULL, `bam_message` varchar(128) NOT NULL, `fileformat` varchar(6) NOT NULL, `has_error` varchar(4) NOT NULL, `dir_md5` varchar(32) NOT NULL, `authentic` varchar(1) NOT NULL, PRIMARY KEY (`md5`), KEY `fileformat` (`fileformat`), KEY `bam_message` (`bam_message`), KEY `label` (`label`)) ENGINE=MyISAM DEFAULT CHARSET=latin1;");    
    $this->query("CREATE TABLE IF NOT EXISTS `media_entries` (`id` int(11) NOT NULL AUTO_INCREMENT, `media_md5` varchar(32) NOT NULL, `data_md5` varchar(32) NOT NULL, `filename` varchar(24) NOT NULL, `blocks` int(11) NOT NULL, `filetype` varchar(6) NOT NULL, PRIMARY KEY (`id`), KEY `data_md5` (`data_md5`), KEY `media_md5` (`media_md5`), KEY `filetype` (`filetype`), KEY `blocks` (`blocks`), KEY `filename` (`filename`)) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;");   
    $this->query("CREATE TABLE IF NOT EXISTS `operative_systems` (`id` int(11) NOT NULL AUTO_INCREMENT, `name` varchar(40) NOT NULL, PRIMARY KEY (`id`)) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;");   
    $this->query("INSERT INTO `operative_systems` (`id`, `name`) VALUES (1, 'C64'),(2, 'C16'),(3, 'C+4'),(4, 'C128'),(5, 'VIC20'),(6, 'Unknown');");  
    $this->query("CREATE TABLE IF NOT EXISTS `previews` (`id` int(11) NOT NULL AUTO_INCREMENT, `release_id` int(11) NOT NULL, `preview_type_id` int(11) NOT NULL, `description` varchar(255) NOT NULL, `extension` varchar(10) NOT NULL, PRIMARY KEY (`id`), KEY `release_id` (`release_id`), KEY `preview_type_id` (`preview_type_id`)) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;");      
    $this->query("CREATE TABLE IF NOT EXISTS `preview_types` (`id` int(11) NOT NULL AUTO_INCREMENT,`type` varchar(20) NOT NULL, PRIMARY KEY (`id`)) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;");      
    $this->query("INSERT INTO `preview_types` (`id`, `type`) VALUES (1, 'image'), (2, 'video');;");  
    $this->query("CREATE TABLE IF NOT EXISTS `publishers` (`id` int(11) NOT NULL AUTO_INCREMENT, `publisher_type_id` int(11) NOT NULL, `name` varchar(255) NOT NULL, `short` varchar(20) NOT NULL, `base_country` varchar(100) NOT NULL, PRIMARY KEY (`id`), KEY `publisher_type_id` (`publisher_type_id`)) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;");   
    $this->query("CREATE TABLE IF NOT EXISTS `publisher_types` (`id` int(11) NOT NULL AUTO_INCREMENT, `name` varchar(100) NOT NULL, PRIMARY KEY (`id`)) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;");   
    $this->query("INSERT INTO `publisher_types` (`id`, `name`) VALUES (1, 'Commercial'), (2, 'Non-commercial'), (3, 'Private'), (4, 'Govermental');;");  
    $this->query("CREATE TABLE IF NOT EXISTS `releases` (`id` int(11) NOT NULL AUTO_INCREMENT, `name` varchar(128) NOT NULL, `date` date NOT NULL DEFAULT '0000-00-00', `subject` varchar(100) NOT NULL, `description` varchar(200) NOT NULL, `coverage` varchar(100) NOT NULL, `creator` varchar(100) NOT NULL DEFAULT '', `identifier` varchar(200) NOT NULL DEFAULT '', `language` varchar(10) NOT NULL DEFAULT '', `rights` varchar(100) NOT NULL DEFAULT '', `contributer` varchar(100) NOT NULL DEFAULT '', `audiance` varchar(100) NOT NULL, `rightsholder` varchar(100) NOT NULL, PRIMARY KEY (`id`)) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;");   
    $this->query("CREATE TABLE IF NOT EXISTS `release_genre` (`id` int(11) NOT NULL AUTO_INCREMENT,`genre` varchar(20) NOT NULL, PRIMARY KEY (`id`)) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;");   
    $this->query("INSERT INTO `release_genre` (`id`, `genre`) VALUES (1, 'Game'), (2, 'Demo'), (3, 'Magazine'), (4, 'Tool'), (5, 'Picture'), (6, 'Logo'), (7, 'Music') ;");   
    $this->query("CREATE TABLE IF NOT EXISTS `data_genre` (`data_md5` varchar(32) NOT NULL, `genre_id` int(11) NOT NULL, PRIMARY KEY (`data_md5`),  KEY `genre_id` (`genre_id`) ) ENGINE=MyISAM DEFAULT CHARSET=latin1;"); 
    $this->query("CREATE TABLE IF NOT EXISTS `release_publishers` (`data_md5` varchar(32) NOT NULL , `publisher_id` int(11) NOT NULL, KEY `publisher_id` (`publisher_id`), KEY `data_md5` (`data_md5`)) ENGINE=MyISAM  DEFAULT CHARSET=latin1 ;");   
    $this->query("CREATE TABLE IF NOT EXISTS `release_types` (`id` int(11) NOT NULL AUTO_INCREMENT, `type` varchar(40) NOT NULL,  PRIMARY KEY (`id`) ) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;");   
    $this->query("INSERT INTO `release_types` (`id`, `type`) VALUES (1, 'Crack'), (2, 'Import'), (3, 'Trainer'), (4, 'Tagged');");   
    $this->query("CREATE TABLE IF NOT EXISTS `status` (`id` int(11) NOT NULL AUTO_INCREMENT, `name` varchar(20) NOT NULL, `order` int(11) NOT NULL, PRIMARY KEY (`id`)) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;");   
    $this->query("INSERT INTO `status` (`id`, `name`, `order`) VALUES (1, 'Unknown', 2),(2, 'Working', 1),(3, 'Corrupt', 3);");  
   }


   function kill_database() 
   {
      $this->query(" DROP DATABASE " . DATABASE );
   }


   function truncate_database()
   {
   	  $this->query(" TRUNCATE TABLE `$this->tbl_collections` " ); 	
   	  $this->query(" TRUNCATE TABLE `$this->tbl_media` " ); 	
   	  $this->query(" TRUNCATE TABLE `$this->tbl_hyper_media` " ); 	
   	  $this->query(" TRUNCATE TABLE `$this->tbl_media_entries` " ); 	
   	  $this->query(" TRUNCATE TABLE `$this->tbl_data` " );
   	  # Dont truncate static information... during DB-structure updates...
      # $this->query(" TRUNCATE TABLE `$this->tbl_releases` " );
   }

  function truncate_publishers(){
      $this->query(" TRUNCATE TABLE `$this->tbl_publishers` " );  
  }
   
   /* -------------------------------------------------------------------------- 
     Database Query commands   
   ----------------------------------------------------------------------------- */
   
   function query($query) 
   {
       $result = mysql_query($query, $this->link);
       if (!$result) {die(NL.'<font color=red><i>Invalid query: ' . mysql_error() . '</font></i>');} else return $result;
   }
   

   function num_results($query)
   {
    return mysql_num_rows($this->query($query));  	
   }
   
   
   /* -------------------------------------------------------------------------- 
    *
    *  Searching ....
    *
   ----------------------------------------------------------------------------- */

   function search($searchstring=NULL, $search_type='filename', $filetype=NULL, $filesize=NULL, $order=NULL){
    $searchstring = str_replace("%", "\\%",$searchstring);
    $searchstring = str_replace("", "%",  $searchstring);
    
    if  ($search_type=='filename')
    {
        $orderby = ($order<>'md5') ? " ORDER BY filename, D.block_1, D.md5, status_order, fileformat, error_bits " 
                                   : " ORDER BY D.block_1, D.md5, filename, status_order, fileformat, error_bits ";
        
        if      ($filetype){$ftype= " and filetype LIKE '$filetype' ";}
        else if ($filesize){$ftype= " and blocks LIKE '$filesize' ";}
        else               {$ftype= " ";}  
    
        return $this->query(" 
        SELECT ME.*, M.fileformat, D.id as data_id, M.dir_md5, D.bytes,
                     D.comment, D.error_bits, D.sysline, HM.id as hyper_media_id,
                     S.name as 'status', DR.release_id as 'release_id', ME.id as 'media_entry_id',
                     OS.name as 'operative_system', R.name as 'release_name', S.order as 'status_order' 
        FROM $this->tbl_media_entries AS ME
        LEFT JOIN $this->tbl_data AS D ON D.md5=ME.data_md5 
        LEFT JOIN $this->tbl_operative_systems AS OS ON OS.id=D.operative_system_id 
        LEFT JOIN $this->tbl_status AS S ON S.id=D.status_id 
        LEFT JOIN $this->tbl_data_release AS DR ON DR.data_md5=D.md5
        LEFT JOIN $this->tbl_releases AS R ON R.id=DR.release_id
        LEFT JOIN $this->tbl_media AS M ON M.md5=ME.media_md5  
        LEFT JOIN $this->tbl_hyper_media AS HM ON HM.media_md5=M.md5 
        WHERE $search_type LIKE \"$searchstring\" $ftype $fsize        
        $orderby
        "); 

    }
    elseif  ($search_type=='sysline')
    {
        $orderby = ($order<>'name') ? " ORDER BY D.block_1, D.md5, filename " 
                                    : " ORDER BY filename, D.block_1, D.md5 ";

        if      ($filetype){$ftype= " and filetype LIKE '$filetype' ";}
        else if ($filesize){$ftype= " and blocks LIKE '$filesize' ";}
        else               {$ftype= " ";}  
    
        return $this->query(" 
        SELECT ME.*, M.fileformat, D.id as data_id, M.dir_md5,
                     D.comment, D.error_bits, D.sysline, HM.id as hyper_media_id,
                     S.name as 'status', DR.release_id as 'release_id', ME.id as 'media_entry_id',
                     OS.name as 'operative_system', R.name as 'release_name' 
        FROM $this->tbl_data AS D
        LEFT JOIN $this->tbl_media_entries AS ME ON ME.data_md5=D.md5 
        LEFT JOIN $this->tbl_operative_systems AS OS ON OS.id=D.operative_system_id 
        LEFT JOIN $this->tbl_status AS S ON S.id=D.status_id 
        LEFT JOIN $this->tbl_data_release AS DR ON DR.data_md5=D.md5
        LEFT JOIN $this->tbl_releases AS R ON R.id=DR.release_id
        LEFT JOIN $this->tbl_media AS M ON M.md5=ME.media_md5  
        LEFT JOIN $this->tbl_hyper_media AS HM ON HM.media_md5=M.md5 
        WHERE $search_type LIKE \"$searchstring\" $ftype $fsize 
        $orderby
        "); 
    }
    elseif  ( ($search_type=='label') || ($search_type=='bam_message') )
    {
        return $this->query(" 
          SELECT M.md5 as 'media_md5', M.*, HM.id as hyper_media_id 
          FROM $this->tbl_media AS M
          LEFT JOIN $this->tbl_hyper_media AS HM ON HM.media_md5=M.md5       
          WHERE $search_type LIKE \"$searchstring\" 
          ORDER BY label
        "); 
    }
    else
    {
      return null;
    }    
    }
   
   
   
   /* -------------------------------------------------------------------------- 
    *
    *  Prepare download : Send file to browser 
    *
   ----------------------------------------------------------------------------- */
    
 
    function download_media($hyper_media_id, $filename=NULL, $path)
   {
    /* GET INTERNAL FILE FUNCTION */  
    if ($hyper_media_id){
      $hyper_media     = mysql_fetch_array($this->get_hyper_media($hyper_media_id));
      $filename        = $path . $hyper_media["source"];
    }
    
    if ( (file_exists($filename)) AND is_file($filename) )
    {
      header("Content-Disposition: attachment; filename=\"".basename($filename)."\"");
      header("Content-Type: application/octetstream");
      header("Content-Length: ".filesize($filename)); 
      header("Cache-Control: no-cache, must-revalidate"); 
      header("Pragma: no-cache");
  
      $fp = fopen($filename,"r");
      if ($fp===false){echo "Error opening file: $filename <br><br>Please contact admin! ";}
      else{ echo fread( $fp, filesize($filename) ); fclose($fp); exit();}
    }
    else
    {
      echo "<h2>File does not exist! Please contact admin!</h2>".$filename."<br>";  
    }
   }
 
   
   /* -------------------------------------------------------------------------- 
    *
    *  Collections
    *
   ----------------------------------------------------------------------------- */
   
  function add_collection($name)
  {
   $result = null;
   if ( ($this->collection_name_exists($name)==0) AND ($name) ){
    $this->query(" INSERT INTO $this->tbl_collections (name, created) VALUE (\"$name\", NOW()); ");
    $result = mysql_insert_id();    
   }
   return $result;     
  }


  function delete_collection($coll_id, $update_only = FALSE)
  {
   $collection = $this->get_collections($coll_id);
   # Delete Collection
   if (!$update_only){
    $this->query(" DELETE FROM $this->tbl_collections WHERE id=\"$coll_id\" ");
   }
   # Remember which Hyper-Media were deleted
   $SQLremoved_hyper_media = $this->query(" SELECT media_md5 FROM $this->tbl_hyper_media WHERE collection_id=\"$coll_id\" GROUP BY media_md5 "); 
   # Delete Hyper_media relations
   $this->query(" DELETE FROM $this->tbl_hyper_media WHERE collection_id=\"$coll_id\" ");
   #Find lost medias
   while ($medium = mysql_fetch_array($SQLremoved_hyper_media, MYSQL_ASSOC)) {
    $media_md5 = $medium['media_md5'];
    if(mysql_num_rows($this->query("SELECT media_md5 FROM $this->tbl_hyper_media WHERE media_md5=\"$media_md5\" "))==0){
      # Delete Lost media
      $this->query(" DELETE FROM $this->tbl_media WHERE md5=\"$media_md5\" ");    
      #Find potential lost Data
      $SQLremoved_ME = $this->query(" SELECT data_md5 FROM $this->tbl_media_entries WHERE media_md5=\"$media_md5\" GROUP BY data_md5 "); 
      # DELETE lost Media Entries
      $this->query(" DELETE FROM $this->tbl_media_entries WHERE media_md5=\"$media_md5\" ");
      while ($data = mysql_fetch_array($SQLremoved_ME, MYSQL_ASSOC)) {
        $data_md5 = $data['data_md5'];
        if (mysql_num_rows($this->query("SELECT data_md5 FROM $this->tbl_media_entries WHERE data_md5=\"$data_md5\" "))==0){
          $this->query(" DELETE FROM $this->tbl_data WHERE md5='$data_md5' ");
        }
      }
    }
   }
   if ($collection) {$result = mysql_fetch_array($collection);}
   return $result["name"];  
  }
   
  
  function collection_name_exists($coll_name)
  {   
    $result = mysql_fetch_array($this->query(" SELECT id FROM $this->tbl_collections WHERE name='$coll_name' "));
    return $result["id"]; 
  }


  function get_collection_size($coll_id=NULL)
  {
    $collection = ($coll_id) ? " WHERE C.id='$coll_id' " : "";
  	$query = " SELECT Count(*) AS 'NumOfFiles', C.name FROM $this->tbl_hyper_media as HM LEFT JOIN $this->tbl_collections AS C ON C.id=HM.collection_id $collection GROUP BY name ORDER BY name "; 
    $result = mysql_fetch_array($this->query($query));
    return $result["NumOfFiles"];
  }      


  function get_collections($coll_id=NULL)
  {
    $collection = ($coll_id) ? " WHERE C.id='$coll_id' " : "";
  	$query = " SELECT C.* FROM $this->tbl_collections AS C $collection GROUP BY C.name ORDER BY C.name ";
    return $this->query($query);  
  }

  function get_num_redundants_in_collection($coll_id=NULL)
  {
    $collection = ($coll_id) ? " WHERE collection_id='$coll_id' " : "";
  	$query = " SELECT distinct(media_md5) FROM $this->tbl_hyper_media AS HM $collection ";
    return mysql_num_rows($this->query($query));   
  }

  function get_num_uniques_in_collection($coll_id=NULL)
  {
  	$query = " 
              SELECT count(*) AS 'antal' FROM $this->tbl_hyper_media AS HM1
              JOIN $this->tbl_hyper_media AS HM2 ON HM1.media_md5=HM2.media_md5 and HM2.collection_id=$coll_id
              GROUP BY HM1.media_md5 HAVING antal = 1   
             ";
    return mysql_num_rows($this->query($query));   
  }

  function get_collection_info($coll_id=NULL){
    $collection = ($coll_id) ? " WHERE C.id='$coll_id' " : "";

    $query = " 
      SELECT Count(*) AS 'NumOfFiles', C.*, M.fileformat
      FROM $this->tbl_collections AS C
      LEFT JOIN $this->tbl_hyper_media AS HM ON HM.collection_id=C.id
      LEFT JOIN $this->tbl_media AS M ON M.md5=HM.media_md5
      $collection
      GROUP BY C.name, fileformat
      ORDER BY C.name, fileformat 
    ";
  	return $this->query($query);
  }      
   

   /* -------------------------------------------------------------------------- 
    *
    *  Image types
    *
   ----------------------------------------------------------------------------- */
   
   function get_image_types(){
    return $this->query(" SELECT fileformat FROM $this->tbl_media GROUP BY fileformat ");
   }
   
   
   
   /* -------------------------------------------------------------------------- 
    *
    *  Media & Hyper Media
    *
   ----------------------------------------------------------------------------- */
   
   
  function add_media(&$coll_id, &$media, $source, &$c64_object, &$os_id, &$media_md5){
      $Lbasic_num = array(chr(143),chr(158),chr(151),chr(139),chr(194),chr(167),chr(153),chr(137),chr(156),chr(178),chr(164),chr(170),chr(177),chr(179),chr(134),chr(199),chr(141),chr(129),chr(135),chr(195),chr(202),chr(130),chr(142),chr(131),chr(169),chr(181),chr(187),chr(153),chr(161),chr(175),chr(171),chr(172),chr(173),chr(176),chr(163),chr(166),chr(23),chr(162),chr(20),chr(128),chr(19),chr(18),chr(145),chr(15),chr(5),chr(198),chr(186),chr(190),chr(191),chr(192),chr(133),chr(189),chr(160),chr(1),chr(136),chr(138),chr(147),chr(140) ,chr(155),chr(144),chr(196),chr(200),chr(201),chr(174),chr(132),chr(146),chr(148),chr(149),chr(150),chr(152),chr(154),chr(157),chr(159),chr(165),chr(168),chr(197) ); 
      $Lbasic_val = array('REM'   ,'SYS'   ,'POKE'  ,'IF'    ,'PEEK'  ,'THEN'  ,'PRINT' ,'GOTO'  ,'CLR'   ,'='     ,'TO'    ,'+'     ,'>'     ,'<'     ,'DIM'   ,'CHR$'  ,'GOSUB' ,'FOR'   ,'READ'  ,'LEN'   ,'MID'   ,'NEXT'  ,'RETURN','DATA'  ,'STEP'  ,'INT'   ,'RND'   ,'AND'   ,'GET'   ,'AND'   ,'-'     ,'*'     ,'/'     ,'OR'    ,'(TAB' , '(SPC'  ,''     ,'NEW'   ,' '    ,'END'   ,' '    ,' '    ,'ON'    ,''     ,''    ,'ASC'   ,'SQR'   ,'SIN'   ,'COS'   ,'TAN'   ,'INPUT' ,'EXP'   ,'CLOSE' ,' '   ,'LET'   ,'RUN'   ,'LOAD'  ,'RESTORE','LIST'  ,'STOP'  ,'STR$'  ,'LEFT$' ,'RIGHT$','^'     ,'INPUT#','WAIT'  ,'SAVE'  ,'VERIFY','DEF'   ,'PRINT#','CONT'  ,'CMD'   ,'OPEN'  ,'FN',   'NOT'    ,'VAL'   );  
      $dir_md5    = "";
      # add hyper_media
      $this->query(" INSERT INTO $this->tbl_hyper_media (collection_id, media_md5, source) VALUE (\"$coll_id\", \"$media_md5\", \"$source\"); ");

      # add media if it does not exist
      $result = mysql_fetch_array($this->get_media($media_md5));
      if (!$result["md5"]){

        # Media did not exist => some data must be new. Find and Add them
        $values      = "";
        $dir_size = sizeOf($c64_object->directory);
        for ($i=0;$i<$dir_size;$i++){
        $dir_element        = $c64_object->directory[$i];
        $entry_data_md5     = md5($dir_element['filedata']);
        $entry_filename     = strtoupper(replace_bad_chars($dir_element['filename']));
        $values .= "(\"$entry_data_md5\", \"$media_md5\", \"$entry_filename\", \"".$dir_element['filetype']."\", \"".$dir_element['filesizeblocksest']."\" ),";
        if ( ($dir_element['filetype']=='PRG') && ($dir_element['filesizeblocksest']>4) ){
          $dir_md5 .= $entry_filename;
        }
        
        
        # Add *only* new data 
        if (!$this->data_md5_exist($entry_data_md5)){
          $entry_sysline = " ";
          $basic_length  = 200;
          
          // check that we have a C64 - BASIC begin in $0801 => SYS may exist!  
          $data = substr($dir_element['filedata'],0,$basic_length);
          $u = @unpack("vstart", substr($data, 0, 2));
          if ($u["start"]==2049)
          {
            # [start ]: addr of basic line begin
            # [length]: of current basic line
            # Search hex-code(#$9E) for BASIC command "SYS"
            $k = strpos($data,''); 
            if ( ($k<$basic_length) && ($k>0) )  {
              $end_basic = strpos($data, chr(0).chr(0).chr(0)) - 1;
              # if no BASIC end is found in substring(data), then set it to max.
              if ($end_basic==-1){$end_basic=strpos($data, chr(0)) - 1;}
              
              $pos = 2;       # start position of BASIC CODE
              $basic_entry=0; # count current basic line-numbers
              while ( ($pos<$end_basic) && ($basic_entry<2) ){
                $u = @unpack("vEndadr/vLine", substr($data, $pos, 4));                
                $token = strtok(substr($data, $pos+4, $basic_length), chr(0));
                $entry_sysline .= $u["Line"] . ' ' . str_replace($Lbasic_num, $Lbasic_val, $token) . ' ';
                $basic_entry++;
                $pos += strlen($token) + 5;
              }
            }
          }            
          
        $entry_data         = $dir_element['filedata'];        
        $this->query(" INSERT INTO $this->tbl_data (md5, sysline, bytes, error_bytes, error_bits, data, block_1, operative_system_id)
                       VALUES 
                            (\"$entry_data_md5\",
                            \"".addslashes($entry_sysline)."\",
                            \"".$dir_element['filesize']."\", 
                            \"".$dir_element['error_blocks']."\",
                            \"".$dir_element['error']."\",
                            \"\",
                            \"".addslashes(substr($entry_data,0,254))."\",
                            \"$os_id\"
                            ) 
                     ");             
          } #}
          # UPDATE if we have some "more" error info...
          else if ( (!$result["error_bits"]) && ($dir_element["error"]>0) ) {
            $this->query(" UPDATE data SET error_bits=\"".$dir_element['error']."\", error_bytes=\"".$dir_element['error_blocks']."\" WHERE md5=\"$entry_data_md5\" "); 
          }
        }

        if ($dir_md5<>"") {$dir_md5=md5($dir_md5);}
        $this->query(" INSERT INTO $this->tbl_media SET 
                       md5=\"$media_md5\",
                       label=\"".addslashes($c64_object->full_label)."\",
                       bam_message=\"".addslashes(replace_bad_chars($c64_object->bam_message))."\",
                       has_error=\"$c64_object->bool_error_inatleastone_file\",
                       fileformat=\"$c64_object->archive_format\",
                       dir_md5=\"$dir_md5\"
                    ");        
        
        if ($values){
        # Add relation betweem media and data
        $values[strlen($values)-1] = ""; # remove last ',''
        $this->query(" INSERT INTO $this->tbl_media_entries 
                       (data_md5, media_md5, filename, filetype, blocks) 
                       VALUES " . $values );
        }
        
        
      } # END::add media if it does not exist
      else{
        # Media exists already in system, so check if DATA.Operative_system_id == unknown
        # And update "unknowns" to current "operative system" if different from Unknown!
        # .
        # .  -- missing code --
        # .
      }
  }


   function get_media_dir_md5($dir_md5)
   { 	
    $query = " 
      SELECT dir_md5, label, fileformat, md5, HM.id 
      FROM $this->tbl_media
      LEFT JOIN $this->tbl_hyper_media AS HM ON HM.media_md5=md5
      WHERE dir_md5=\"$dir_md5\"
    ";   
    return mysql_query($query);
   }
   
  function add_hyper_media(&$coll_id, $source, &$media_md5){
    $this->query(" INSERT INTO $this->tbl_hyper_media (collection_id, media_md5, source) VALUE (\"$coll_id\", \"$media_md5\", \"$source\"); "); 
  } 
   
   
  function get_hyper_media($hyper_media_id){
    return $this->query(" SELECT HM.*
                          FROM $this->tbl_hyper_media AS HM
                          WHERE HM.id=\"$hyper_media_id\" 
                        ");
  } 


  function get_hyper_media_md5($data_md5){
    return $this->query(" SELECT HM.* 
                          FROM $this->tbl_media_entries as ME
                          LEFT JOIN $this->tbl_hyper_media AS HM ON HM.media_md5=ME.media_md5
                          WHERE ME.data_md5=\"$data_md5\"
                          GROUP BY HM.media_md5 
                        ");
  }   


  function get_hyper_media_2($media_md5){
    return $this->query(" SELECT HM.*, C.* 
                          FROM $this->tbl_hyper_media AS HM
                          LEFT JOIN $this->tbl_collections AS C ON C.id=HM.collection_id
                          WHERE HM.media_md5=\"$media_md5\"
                          GROUP BY HM.media_md5 
                        ");
  } 

   
  function get_media($media_md5){
    return $this->query(" SELECT * FROM $this->tbl_media WHERE md5=\"$media_md5\" ");
  } 


  function media_md5_exist($media_md5){
    $row = mysql_fetch_array($this->query(" SELECT * FROM $this->tbl_media WHERE md5=\"$media_md5\" "));
    return $row['md5']; 
  } 

  function data_md5_exist($md5)
  {
    $row = mysql_fetch_array($this->query("SELECT md5 FROM $this->tbl_data as D WHERE D.md5='$md5'"), MYSQL_ASSOC);
  	return $row['md5']; 
  }
   
  
   function get_media_entries($data_md5){
    return $this->query(" SELECT ME.*, M.fileformat, HM.id as 'hyper_media_id' 
                          FROM $this->tbl_media_entries AS ME
                          LEFT JOIN $this->tbl_media AS M ON M.md5=ME.media_md5
                          LEFT JOIN $this->tbl_hyper_media AS HM ON HM.media_md5=M.md5
                          WHERE data_md5=\"$data_md5\" ");
  }   
    
   
  function get_data($data_md5){
    return $this->query(" SELECT * FROM $this->tbl_data WHERE md5=\"$data_md5\" ");
  }   

  
  function get_data_hypermedia($media_entry_id){
    return $this->query(" SELECT D.*, HM.source, S.name as 'status', ME.filename, HM.id as 'hyper_media_id' 
                          FROM $this->tbl_data AS D
                          LEFT JOIN $this->tbl_media_entries AS ME ON ME.data_md5=D.md5
                          LEFT JOIN $this->tbl_hyper_media AS HM ON HM.media_md5=ME.media_md5
                          LEFT JOIN $this->tbl_status AS S ON S.id=D.status_id
                          WHERE ME.id=\"$media_entry_id\" 
                          GROUP BY D.md5
                        ");
  } 
  
  function get_release_info($data_md5){
    return $this->query(" SELECT R.*, D.sysline, D.comment, D.error_bits, D.id as 'data_id', D.bytes, 
                                      D.error_bytes, P.name as 'publisher_name', R.date, S.name as 'status',
                                      P.id as 'publisher_id', RG.genre, DR.release_id as 'release_id',
                                      P.short as 'publisher_short', OS.name as 'operative_system',
                                      P2.short as 'modifier_short', P2.id as 'modifier_id', 
                                      P2.name as 'modifier_name', RT.type as 'modifier_type'
                          FROM $this->tbl_data AS D
                          LEFT JOIN $this->tbl_data_release AS DR ON DR.data_md5=D.md5                           
                          LEFT JOIN $this->tbl_data_publishers AS DP ON DP.data_md5=D.md5
                          LEFT JOIN $this->tbl_operative_systems AS OS ON OS.id=D.operative_system_id 
                          LEFT JOIN $this->tbl_status AS S ON S.id=D.status_id
                          LEFT JOIN $this->tbl_releases AS R ON R.id=DR.release_id
                          LEFT JOIN $this->tbl_data_genre AS DG ON DG.data_md5=D.md5
                          LEFT JOIN $this->tbl_release_genre AS RG ON RG.id=DG.genre_id
                          LEFT JOIN $this->tbl_release_publishers AS RP ON RP.data_md5=D.md5
                          LEFT JOIN $this->tbl_publishers AS P ON P.id=RP.publisher_id
                          LEFT JOIN $this->tbl_publishers AS P2 ON P2.id=DP.publisher_id
                          LEFT JOIN $this->tbl_release_types AS RT ON RT.id=DP.release_type_id                          
                          WHERE D.md5=\"$data_md5\" 
                          ORDER BY publisher_name                         
                        ");
  }   
   

  function get_release_previews($release_id, $preview_type=NULL){
    $where = $preview_type ? " AND PREVT.type=\"$preview_type\" " : "";
    return $this->query(" SELECT PREV.*, PREVT.type as 'preview_type'
                          FROM $this->tbl_previews AS PREV
                          LEFT JOIN $this->tbl_preview_types AS PREVT ON PREVT.id=PREV.preview_type_id
                          WHERE PREV.release_id=\"$release_id\" $where
                          ORDER BY preview_type                          
                        ");  
  }


  function get_preview_types(){
    return $this->query(" SELECT * FROM $this->tbl_preview_types AS PREVT ORDER BY type ");
  }
  
  function add_preview($file_extension, $release_id, $preview_type_id){
          $this->query(" INSERT INTO $this->tbl_previews SET
                         release_id      = \"$release_id\",
                         preview_type_id = \"$preview_type_id\",
                         extension       = \"$file_extension\"
                     ");
          return mysql_insert_id();
  }
  
  
  function update_media_comment($media_md5, $comment){
      $this->query(" UPDATE $this->tbl_media SET comment=\"".htmlentities($comment)."\" WHERE md5=\"$media_md5\" "); 
  } 

  function update_data_status($data_md5, $status_id){
      $this->query(" UPDATE $this->tbl_data SET status_id=\"$status_id\" WHERE md5=\"$data_md5\" "); 
  }

  function update_data_os($data_md5, $os_id){
      $this->query(" UPDATE $this->tbl_data SET operative_system_id=\"$os_id\" WHERE md5=\"$data_md5\" "); 
  }

  function remove_publisher_from_release($publisher_id, $data_md5){
      $this->query(" DELETE FROM $this->tbl_release_publishers WHERE publisher_id=\"$publisher_id\" AND data_md5=\"$data_md5\"  "); 
  } 

  function remove_preview_from_release($preview_id){
      $preview = mysql_fetch_array($this->query(" SELECT * FROM $this->tbl_previews WHERE id=\"$preview_id\" "));
      if ($preview) {unlink(ARCHIVE_IMAGES.$preview['id'].".".$preview['extension']);}
      $this->query(" DELETE FROM $this->tbl_previews WHERE id=\"$preview_id\" ");   
  }


  function get_publisher_types($publisher_type_id=NULL){
    $where = $publisher_id ? " WHERE PT.id=$publisher_type_id " : "";
    return $this->query(" SELECT PT.* FROM $this->tbl_publisher_types AS PT 
                          $where ORDER BY name ");
  }


  function get_publishers($publisher_id=NULL){
    $where = $publisher_id ? " WHERE P.id=$publisher_id " : "";
    return $this->query(" SELECT P.* FROM $this->tbl_publishers AS P 
                          $where ORDER BY name ");
  }


  function add_publisher($name){
    if ($name){
      $this->query(" INSERT INTO $this->tbl_publishers SET name=\"$name\" ");
    }
  }

  
  function add_publisher_2($id, $name, $short, $country, $type_id){
    $this->query(" INSERT INTO $this->tbl_publishers (id, name, short, base_country ,publisher_type_id) VALUE (\"$id\", \"$name\", \"$short\", \"$country\" , \"$type_id\"); ");
  }

  function update_publisher($pub_id, $name, $short, $type_id){
    if ($pub_id){
      $this->query(" UPDATE $this->tbl_publishers SET name=\"$name\", short=\"$short\", publisher_type_id=\"$type_id\" WHERE id=\"$pub_id\" ");
    }
  }

  function get_release_types(){
    return $this->query(" SELECT * FROM $this->tbl_release_types AS RT ORDER BY type ");
  }

  function get_operative_systems(){
    return $this->query(" SELECT * FROM $this->tbl_operative_systems AS OS ORDER BY id ");
  }

  function get_genre(){
    return $this->query(" SELECT * FROM $this->tbl_release_genre AS RG ORDER BY genre ");
  }

  function get_status(){
    return $this->query(" SELECT * FROM $this->tbl_status AS S ORDER BY name ");
  }

  function set_genre_to_release($genre_id, $data_md5){
    $result = mysql_fetch_array($this->query(" SELECT data_md5 FROM $this->tbl_data_genre WHERE data_md5=\"$data_md5\" "));
    if ($result) {
      $this->query(" UPDATE $this->tbl_data_genre SET genre_id=\"$genre_id\" WHERE data_md5=\"$data_md5\" ");
    } else {
      $this->query(" INSERT INTO $this->tbl_data_genre SET genre_id=\"$genre_id\", data_md5=\"$data_md5\" ");
    }    
  }

  function set_release_info($release_id, $name, $subject, $desc, $coverage, $date,
                            $creator, $identifier, $language, $rights, $contributer,
                            $audiance, $rightsholder){
    $this->query(" UPDATE $this->tbl_releases SET 
                   name=\"$name\", subject=\"$subject\", description=\"$desc\", 
                   coverage=\"$coverage\", date=\"$date\", creator=\"$creator\",
                   identifier=\"$identifier\", language=\"$language\",
                   rights=\"$rights\", contributer=\"$contributer\", 
                   audiance=\"$audiance\", rightsholder=\"$rightsholder\"
                   WHERE id=\"$release_id\" ");
  }

  
  function set_publisher_to_release($publisher_id, $data_md5){
    $exist = mysql_fetch_array($this->query(" SELECT * FROM $this->tbl_release_publishers WHERE data_md5=\"$data_md5\" AND publisher_id=\"$publisher_id\" "));
    if (!$exist) {$this->query(" INSERT INTO $this->tbl_release_publishers SET data_md5=\"$data_md5\", publisher_id=\"$publisher_id\" ");}
  }
   
  function set_data_to_publisher($data_md5, $publisher_id, $release_type_id){
    $exist = mysql_fetch_array($this->query(" SELECT * FROM $this->tbl_data_publishers WHERE data_md5=\"$data_md5\" AND publisher_id=\"$publisher_id\" "));
    if (!$exist) {$this->query(" INSERT INTO $this->tbl_data_publishers SET data_md5=\"$data_md5\", publisher_id=\"$publisher_id\", release_type_id=\"$release_type_id\" ");}
  }

  function set_preview_description($preview_id, $description){
    $this->query(" UPDATE $this->tbl_previews SET description=\"$description\" WHERE id=\"$preview_id\" ");
  }   
   
  function add_release($release_name, $data_md5){
    $exist = mysql_fetch_array($this->query(" SELECT * FROM $this->tbl_data_release WHERE data_md5=\"$data_md5\" "));
    if (!$exist){
      $this->query(" INSERT INTO $this->tbl_releases SET name=\"$release_name\" ");
      $this->query(" INSERT INTO $this->tbl_data_release SET data_md5=\"$data_md5\", release_id=\"".mysql_insert_id()."\" ");
    }
  }   
   
  function del_release($release_id){
      $this->query(" DELETE FROM $this->tbl_releases WHERE id=\"$release_id\" ");
      $this->query(" DELETE FROM $this->tbl_data_release WHERE release_id=\"$release_id\" ");

      # Delete all previews attached to this release (also files!)
      $SQLpreviw = $this->get_release_previews($release_id);
      while ($preview = mysql_fetch_array($SQLpreviw)){ 
        echo unlink(ARCHIVE_IMAGES.$preview['id'].".".$preview['extension']);
      }      
      $this->query(" DELETE FROM $this->tbl_previews WHERE release_id=\"$release_id\" ");
  } 
   

  function add_dependency($release_id, $data_md5){
    $exist = mysql_fetch_array($this->query(" SELECT * FROM $this->tbl_data_release WHERE data_md5=\"$data_md5\" "));
    if (!$exist){
      $this->query(" INSERT INTO $this->tbl_data_release SET data_md5=\"$data_md5\", release_id=\"$release_id\" ");
      return true;
    }
    else return false;  
  }
  
  function remove_dependencies($data_md5, $release_id){
    $this->query(" DELETE FROM $this->tbl_data_release WHERE data_md5=\"$data_md5\" AND release_id=\"$release_id\" "); 
  } 
  
  function get_dependencies($release_id, $working){
    $is_working = $working ? " AND S.name='Working' " : " AND S.name<>'Working' ";
    return $this->query(" SELECT md5, bytes, error_bits, comment, S.name AS 'status' 
                          FROM $this->tbl_data_release AS DR 
                          LEFT JOIN $this->tbl_data AS D on D.md5=DR.data_md5
                          LEFT JOIN $this->tbl_status AS S ON S.id=D.status_id
                          WHERE release_id=\"$release_id\" $is_working
                        ");
  }


  function get_modifiers($data_md5){
    return $this->query(" SELECT P.name as 'publisher_name', RT.type as 'release_type', 
                          P.id as 'publisher_id'
                          FROM $this->tbl_data_publishers AS DP
                          LEFT JOIN $this->tbl_publishers AS P ON P.id=DP.publisher_id
                          LEFT JOIN $this->tbl_release_types AS RT ON RT.id=DP.release_type_id
                          WHERE DP.data_md5=\"$data_md5\"
                          ORDER BY P.name
                        ");
    
  }  
  
 
  function remove_modifier($data_md5, $publisher_id){
    $this->query(" DELETE FROM $this->tbl_data_publishers WHERE data_md5=\"$data_md5\" AND publisher_id=\"$publisher_id\" ");
  } 
   
   
   
  function import_comments($media_md5, $filename, $filesize=NULL, $comment){
    $SQLresult = $this->query(" SELECT data_md5 FROM $this->tbl_media_entries as ME
                   WHERE media_md5=\"$media_md5\" AND filename=\"$filename\" AND blocks=\"$filesize\" 
                 ");
    
    $row = mysql_fetch_array($SQLresult, MYSQL_ASSOC);
    $val = 0;
    if ($row['data_md5']){
      $md5 = $row['data_md5'];
      $this->query(" UPDATE $this->tbl_data SET comment=\"$comment\" WHERE md5=\"$md5\" ");
      $val = 1;
    }
    return $val;
  }  
   
   
   
   
   
   // -------------------------------------------------------------------------
   // the END.   
   // -------------------------------------------------------------------------
} 
