<?php
// v0.37
// see class_c64reader.php for more info

class LynxImage
{
	var $imagefile = "";
	var $num_entries = 0;
	var $error = "";
	var $entries = array();
	var $title = "";

	function LynxImage(&$image)
	{
		$this->imagefile = $image;

		// getting the first sector, then splitting at <CR>
		$arr = explode("\r", substr($image, 0, 254));
		if (count($arr) < 3)
		{
			$this->error = "Invalid header in Lynx file - not enough data!";
			return;
		}

		$str = trim($arr[1]);
		$pos = strpos($str, " ");
		if ($pos === false)
		{
			$this->error = "Invalid header in Lynx file - error in number of blocks!";
			return;
		}

		$numblocks = (int) substr($str, 0, strpos($str, " "));
		if ($numblocks < 1)
		{
			$this->error = "Invalid header in Lynx file - less than one block specified!";
			return;
		}

        // getting the correct number of sectors and splitting
		$arr = explode("\r", substr($image, 0, $numblocks * 254));

        $str = ltrim($arr[1]);
		$pos = strpos($str, " ");
        $this->title = trim(substr($str, strpos($str, " ")));

		$numfiles = (int) trim($arr[2]);
		if (count($arr) < $numfiles * 4 + 3)
		{
			$this->error = "Invalid header in Lynx file - not enough data in directory!";
			return;
		}

		$block_offset = $numblocks;
		for ($i = 0; $i < $numfiles * 4; $i += 4)
		{
			$entry = array();
			$entry["filename"] = $arr[$i + 3];
			$entry["blocksize"] = (int) trim($arr[$i + 4]);
			$entry["filetype"] = trim($arr[$i + 5]);
			$LSU = (int) trim($arr[$i + 6]);
			$entry["start"] = $block_offset * 254;
			$entry["filesize"] = $entry["blocksize"] * 254 - 255 + $LSU;
			$entry["filedata"] = substr($image, $entry["start"], $entry["filesize"]);
			$entry["end"] = $entry["start"] + $entry['filesize'];
			$block_offset += $entry["blocksize"];
			$entry["error"]     = ($entry["end"] > strlen($image)) ? 'end of entry outside size of image' : '';
			$this->error        = $entry["error"] ? 'error in at least one entry' : '';
			$this->entries[] = $entry;
		}
	}
}
?>
